EXPORTED_SYMBOLS = ["AmiHelper"];

function AmiHelper(){}
AmiHelper.b64array = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
AmiHelper.decode64 = function(input) {
		var output = "";
		var hex = "";
		var chr1, chr2, chr3 = "";
		var enc1, enc2, enc3, enc4 = "";
		var i = 0;

		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

		do {
			enc1 = AmiHelper.b64array.indexOf(input.charAt(i++));
			enc2 = AmiHelper.b64array.indexOf(input.charAt(i++));
			enc3 = AmiHelper.b64array.indexOf(input.charAt(i++));
			enc4 = AmiHelper.b64array.indexOf(input.charAt(i++));
			
			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;
			
			output = output + String.fromCharCode(chr1);
			
			if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				output = output + String.fromCharCode(chr3);
			}
		
			chr1 = chr2 = chr3 = "";
			enc1 = enc2 = enc3 = enc4 = "";
		
		} while (i < input.length);
		return output;
	};

AmiHelper.encodePostData = function (o, prefix) {
        if (!o || typeof o !== 'object') {
            return false;
        }
        var _p, _qs = [], op;
        for (_p in o) {
			op = o[_p];
			if(typeof(op) == 'undefined')continue;
			if(op.constructor == Array){
				for(var i = 0; i<op.length; i++)
					_qs.push(encodeURIComponent(_p + prefix + '[' + i + ']') + '=' + encodeURIComponent(op[i]));
			}
			else if(typeof(op) == 'object')
				_qs.push(AmiHelper.encodePostData(op, _p + '[' + prefix + ']'));
            else _qs.push(encodeURIComponent(_p) + '=' + encodeURIComponent(op));
        }
        _p = _qs.join('&');
		return _p;
    };

AmiHelper.boolVal = function(v){
	switch(typeof(v)){
		case 'undefined': return false;
		case 'number': return v != 0;
		case 'object': return v != null;
		case 'string': return v != 'false';
		default: return v;
	}
};

AmiHelper.numVal = function(v){
	switch(typeof(v)){
		case 'object': 
		case 'undefined': return 0;
		case 'string': return parseInt(v);
		default: return v;
	}
};
